--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- addon.setupWorldMap
addon.setupWorldMap = function()

	if (WorldMapFrame) then
		-- DTools.log("FOUND WORLD MAP FRAME!!!","00FF00");
		-- DTools.createText = function(frame,label,fontSize,justify,x,y,r,g,b,font)
		-- addon.worldMap.label = DTools.createText(
		-- 	WorldMapFrame,
		-- 	addon.tempLabel,
		-- 	DCoordsDB["WorldMap"].labelFontSize,
		-- 	"LEFT",
		-- 	DCoordsDB["WorldMap"].x,
		-- 	DCoordsDB["WorldMap"].y,
		-- 	DCoordsDB["WorldMap"].r,
		-- 	DCoordsDB["WorldMap"].g,
		-- 	DCoordsDB["WorldMap"].b,
		-- 	DTools.defaultFont
		-- );

		local x = DCoordsDB["WorldMap"].x + DCoordsDB["WorldMap"].offsetX
		local y = DCoordsDB["WorldMap"].y + DCoordsDB["WorldMap"].offsetY

		addon.worldMap.label = WorldMapFrame:CreateFontString(nil, 'ARTWORK');
		addon.worldMap.label:SetPoint("TOPLEFT",WorldMapFrame,"TOPLEFT",x,y);
		addon.worldMap.label:SetFont(addon.getWorldMapFont(), DCoordsDB["WorldMap"].fontSize,"OUTLINE");
		addon.worldMap.label:SetShadowOffset(1, -1);
		addon.worldMap.label:SetTextColor(DCoordsDB["WorldMap"].r, DCoordsDB["WorldMap"].g, DCoordsDB["WorldMap"].b);
		addon.worldMap.label:SetNonSpaceWrap(false);
		addon.worldMap.label:SetText(addon.tempLabel);
		addon.worldMap.label:SetJustifyH("LEFT");


	else 
		-- DTools.log("CANT FIND WORLD MAP FRAME","FF0000");
	end
    
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- addon.updateWorldMapLabelText
addon.updateWorldMapLabelText = function()
	-- Do not update the world map when in combat
	if (DTools.isInCombat() == false) then
		
		-- only update world map when its visible
		if (WorldMapFrame:IsVisible()) then
			local worldMapLabel = "";
			worldMapLabel = "Player: " .. addon.coords.x .. DCoordsDB["CoordsSeperationString"] .. addon.coords.y;

			-- Get the cursor's coordinates
			local cursorX, cursorY = GetCursorPosition()
				
			-- Calculate cursor position
			local worldMapCanvas = WorldMapFrame:GetCanvas()
			local scale, width, height, left, top
			if (worldMapCanvas ~= nil) then
				local scale = worldMapCanvas:GetEffectiveScale()
				local width = worldMapCanvas:GetWidth()
				local height = worldMapCanvas:GetHeight()
				local left = worldMapCanvas:GetLeft()
				local top = worldMapCanvas:GetTop()

				addon.worldMap.label:SetText(worldMapLabel);
			
				cursorX = (cursorX - left) / width * 100
				cursorY = (top - cursorY) / height * 100

				local precision = "%.".. DCoordsDB["CoordinatesAccuracy"] .."f";
				cursorX = string.format(precision, cursorX);
				cursorY = string.format(precision, cursorY);

				worldMapLabel = worldMapLabel .. "   Cursor: "..format("%.2f , %.2f    ", cursorX, cursorY)
			end

			
			addon.worldMap.label:SetText(worldMapLabel);
		end

	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





addon.setWorldMapFontStyles = function()
	addon.worldMap.label:SetFont(addon.getWorldMapFont(), DCoordsDB["WorldMap"].fontSize,"OUTLINE");
	addon.updateWorldMapLabelText();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




addon.setWorldMapLabelPosition = function()
	local x = DCoordsDB["WorldMap"].x + DCoordsDB["WorldMap"].offsetX
	local y = DCoordsDB["WorldMap"].y + DCoordsDB["WorldMap"].offsetY;
	addon.worldMap.label:SetPoint("TOPLEFT",WorldMapFrame,"TOPLEFT",x,y);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







addon.initWorldMapState = function()
	if (DCoordsDB["WorldMap"].enabled == true) then
		addon.worldMap.label:Show();
		addon.setWorldMapFontStyles();
		addon.setWorldMapLabelPosition();
	else
		addon.worldMap.label:Hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #